"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.USELESS_ITEMS = exports.CLUE_SCROLL_NAMES = exports.CLUE_SCROLLS = exports.itemNameMap = void 0;
const item_data_json_1 = __importDefault(require("../data/items/item_data.json"));
const cleanString_1 = require("../util/cleanString");
const Collection_1 = __importDefault(require("./Collection"));
// @ts-ignore asdf
const items = item_data_json_1.default;
exports.itemNameMap = new Map();
exports.CLUE_SCROLLS = [
    // Clue scrolls
    2677, 2801, 2722, 12073, 19835, 23182,
];
exports.CLUE_SCROLL_NAMES = [
    "Clue scroll (beginner)",
    "Clue scroll (easy)",
    "Clue scroll (medium)",
    "Clue scroll (hard)",
    "Clue scroll (elite)",
    "Clue scroll (master)",
];
exports.USELESS_ITEMS = [
    617, 8890, 6964, 2513, 19492, 11071, 11068, 21284, 24735, 21913, 4703, 4561, 2425, 4692, 3741,
    // Quest blood vial
    22405,
    // Pharaoh's sceptres
    9045, 9046, 9047, 9048, 9049, 9050, 9051, 13074, 13075, 13076, 13077, 13078, 16176, 21445, 21446, 26948,
    26950, 26945,
    // Removed items
    10639, 10641, 10644, 10646, 10647, 10648, 10649, 10651, 10652, 10654, 10657, 10658, 10659, 10661,
    27794, 27795, 27796, 27797, 27798, 27799, 27800, 27801,
    // Clue scrolls - Duplicate or individual step clues that don't match filter
    3550, 3577, 2793, 12113, 10184, 12027,
    // SOTE Quest Clues
    23814, 23815, 23816, 23817,
];
class Items extends Collection_1.default {
    get(item) {
        const id = this.resolveID(item);
        if (typeof id === "undefined")
            return undefined;
        return super.get(id);
    }
    resolveID(input) {
        if (typeof input === "number") {
            return input;
        }
        if (typeof input === "string") {
            const cleanName = (0, cleanString_1.cleanString)(input);
            return exports.itemNameMap.get(cleanName);
        }
        return undefined;
    }
}
const itemsExport = new Items();
for (const [id, item] of Object.entries(items)) {
    const numID = parseInt(id);
    if (exports.USELESS_ITEMS.includes(numID))
        continue;
    itemsExport.set(numID, item);
    const cleanName = (0, cleanString_1.cleanString)(item.name);
    if (!exports.itemNameMap.has(cleanName))
        exports.itemNameMap.set(cleanName, numID);
}
exports.default = itemsExport;
//# sourceMappingURL=Items.js.map